/*
 * outputBuffer.h
 *
 *  Created on: Mar 22, 2010
 *      Author: torben
 */

#ifndef OUTPUTBUFFER_H_
#define OUTPUTBUFFER_H_

#include <stddef.h>
#include <stdio.h>
#include <inttypes.h>
#include <stdlib.h>

// user defines
#define BUF_DATA_SHFT 0 // adds for each binary output record the length and shifts the record by n  uint32_t words to the right, socket, standardOutput: 1

// local defines
#define BUFFER_DATAP (BUF_DATA_SHFT * 4)

typedef struct outputBuffer_s {
	size_t size_of_buffer;
	uint32_t act_pos;
	char *buffer;
} outputBuffer_t;

outputBuffer_t *outputBuffer_initialize(size_t size_of_buffer);

int outputBuffer_append(outputBuffer_t* buffer, char* output, size_t size_of_output);

int outputBuffer_reset(outputBuffer_t* buffer);

int outputBuffer_destroy(outputBuffer_t* buffer);

#endif /* OUTPUTBUFFER_H_ */
