/*
 * binaryToText.h
 *
 *  Created on: Apr 23, 2010
 *      Author: torben
 */

#ifndef BINARYTOTEXT_H_
#define BINARYTOTEXT_H_

#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <time.h>
#include "binaryValue.h"

// User defines
#define HEX_CAPITAL 0                       // hex output 1: capital; 0: lower case
#define IP_PRINT_NORMALIZE 0                // IP addresses 1: normalized; 0: normal output len
#define IP6_COMPRESS 1                      // IP addresses 1: compressed output; 0: full 128 bit length
#define TEXT_FILE_SINK_EXTENDED_HEADER 0    // Extended header in flow file

//
#define INPUT_TYPE_BUFFER 0
#define INPUT_TYPE_FILE 1
#define B2T_TIME_IN_MICRO_SECS 1 // 1 if time should be printed in microsecs instead of nanosecs

// functions
uint32_t parse_binary_header2text(binary_value_t *bv, int header_type, FILE* output_file);
void parse_binary2text(binary_value_t *bv, FILE* output_file);
void set_input_source(int new_type_of_input, ...);

#endif /* BINARYTOTEXT_H_ */
