/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

/*
 * tranalyzer_utils.h
 *
 * This file provides functions that are or (might be) used by more than one
 * plugin, so that developing and debugging does not become a huge pain. :)
 */

#ifndef TRANALYZER_UTILS_H_
#define TRANALYZER_UTILS_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#include "tranalyzer.h"
#include "networkHeaders.h"

char* loadAscii(char fileName[]);
void print_packet(FILE* stream, packet_t *packet, int width);

#endif /* TRANALYZER_UTILS_H_ */

